grammar Endpoints;

generatorconfig     : '{' (configitem)? (',' configitem)* '}';
configitem          : configkey ':' configvalue ;
configkey           : IDENTIFIER ;
configvalue         : (IDENTIFIER|VALUE) ;
fieldName           : IDENTIFIER ;
fieldType           : IDENTIFIER ;
compoundTypeName    : IDENTIFIER ;
compoundField       : fieldName ':' fieldType ;
compoundFields      : '(' compoundField (',' compoundField)* ')' ;
compoundType        : compoundTypeName compoundFields ;
pathSegment         : '/' (IDENTIFIER|VALUE) ;
path                : (pathSegment)+ ;
endpoint            : path '<' (compoundFields | IDENTIFIER) ;


fragment DIGIT      : [0-9] ;
fragment LOWERCASE  : [a-z] ;
fragment UPPERCASE  : [A-Z] ;
WS                  : [ \t\n\r]+ -> skip;
IDENTIFIER          : (LOWERCASE | UPPERCASE) (LOWERCASE | UPPERCASE | DIGIT)* ;
VALUE               : ~[ ,{}:()\n\t\r/<>"']+  ;
